/*
    QGL Texture2DArray
    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GLTEXTUREARRAY_H
#define GLTEXTUREARRAY_H

#include "gltypes.h"


class QGLENGINE_CORE_EXPORT Texture2DArray {
public:
	Texture2DArray(GLenum format, bool filter);
	~Texture2DArray();

	void init(QOpenGLExtraFunctions * f);
	void destroy(QOpenGLExtraFunctions * f);
	void reinit();

	void bind(QOpenGLExtraFunctions * f, int channel = 0);
	void release(QOpenGLExtraFunctions * f);

	// returns true if size changed
	bool resize(QOpenGLExtraFunctions * f, QSize new_size, int layers_count);
	void load(QOpenGLExtraFunctions * f, const QImage & image, int layer);
	void mipmaps(QOpenGLExtraFunctions * f);

	GLuint ID() const { return texture_; }
	bool isInit() const { return texture_ != 0; }
	int layersCount() const { return layers_; }

private:
	GLenum target_, format_;
	GLuint texture_;
	QSize size_;
	int layers_;
	bool filtering_;
};


#endif // GLTEXTUREARRAY_H
